﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Interactivity;

namespace HowToGetNotifiedOnCollectionCommitEdit
{
    public class DetectAddNewRecordCommitBehavior : Behavior<XamDataGrid>
    {
        protected override void OnAttached()
        {
            base.OnAttached();
            AssociatedObject.PreviewKeyDown += AssociatedObject_PreviewKeyDown;
            AssociatedObject.ExecutedCommand += AssociatedObject_ExecutedCommand;            
            AssociatedObject.CellActivated += AssociatedObject_CellActivated;
        }

        bool isInAddRecord = false;
        bool enterPressedAndAddNewRecordHasDataItem = false;
        private void AssociatedObject_CellActivated(object sender, Infragistics.Windows.DataPresenter.Events.CellActivatedEventArgs e)
        {
            if (e.Cell.Record.IsAddRecord)
            {
                isInAddRecord = true;
            }
            else
            {
                isInAddRecord = false;
            }
        }

        private void AssociatedObject_ExecutedCommand(object sender, Infragistics.Windows.Controls.Events.ExecutedCommandEventArgs e)
        {
            if(e.Command.Name == "EndEditModeAndCommitRecord" && enterPressedAndAddNewRecordHasDataItem)
            {
                //EXTRA CHECK IF NEEDED...
                enterPressedAndAddNewRecordHasDataItem = false;
            }
        }

        private void AssociatedObject_PreviewKeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            if (isInAddRecord)
            {
                if (e.Key == System.Windows.Input.Key.Enter)
                {
                    if (AssociatedObject.ActiveCell != null && AssociatedObject.ActiveCell.IsInEditMode)
                    {
                        DataRecord record = AssociatedObject.ActiveCell.Record as DataRecord;

                        if (record.IsAddRecord && record.DataItem != null)
                        {
                            //THIS WILL COMMIT ADD NEW RECORD
                            enterPressedAndAddNewRecordHasDataItem = true;
                        }          
                    }
                }
            }
        }
    }
}
